package test;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.table.TableModel;


public class MainWindow extends JFrame {

	private JPanel contentPane;
	private JScrollPane scrollPane;
	private JTable table;
	private JButton btnRead;
	private Controller contr;
	

	/**
	 * Create the frame.
	 */
	public MainWindow(final Controller contr) {
		this.contr = contr;
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 666, 403);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		GridBagLayout gbl_contentPane = new GridBagLayout();
		gbl_contentPane.columnWidths = new int[]{0, 0, 0};
		gbl_contentPane.rowHeights = new int[]{0, 0, 0, 0};
		gbl_contentPane.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_contentPane.rowWeights = new double[]{0.0, 0.0, 1.0, Double.MIN_VALUE};
		contentPane.setLayout(gbl_contentPane);		
		
		scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.insets = new Insets(0, 0, 0, 5);
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 2;
		contentPane.add(scrollPane, gbc_scrollPane);
		
		
		/*** Table ***/
		table = new JTable();
		TableModel model = new MyTableModel();		
		table.setModel(model);	
		table.setDefaultRenderer(Person.class, new MyTableRenderer());
		scrollPane.setViewportView(table);
		
		
		btnRead = new JButton("Einlesen");		
		btnRead.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				contr.getGenerator().makePersons();
			}
		});
		GridBagConstraints gbc_btnRead = new GridBagConstraints();
		gbc_btnRead.anchor = GridBagConstraints.NORTH;
		gbc_btnRead.gridx = 1;
		gbc_btnRead.gridy = 2;
		contentPane.add(btnRead, gbc_btnRead);
	}
	
	public JTable getTable() {
		return table;
	}
	
}
